=== debian/changelog ===
gasnet (2025.8.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1126449)

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Feb 2026 08:37:33 +0000
