=== debian/control ===
Source: gasnet
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Section: devel
Build-Depends: debhelper-compat (= 13),
               libhwloc-dev,
               mpi-default-dev,
	       librdmacm-dev [!hurd-any],
	       libslurm-dev (>= 23.11) [!hurd-any],
	       libibverbs-dev,
	       libfabric-dev [!hurd-any !powerpc !sh4],
	       libnuma-dev [!hurd-any],
	       libucx-dev [amd64 arm64 ppc64el riscv64 loong64],
               chrpath
Rules-Requires-Root: no
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/science-team/gasnet
Vcs-Git: https://salsa.debian.org/science-team/gasnet.git -b debian/latest
Homepage: https://www.mpich.org/

Package: libgasnet-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}
Description: Development files for GASNET
 GASNet is a language-independent, networking middleware layer that provides
 network-independent, high-performance communication primitives including
 Remote Memory Access (RMA) and Active Messages (AM).
 It has been used to implement parallel programming models and libraries
 such as UPC, UPC++, Fortran coarrays, Legion, Chapel, and many others.
 The interface is primarily intended as a compilation target and for use
 by runtime library writers (as opposed to end users), and the primary goals
 are high performance, interface portability, and expressiveness.
 GASNet stands for "Global-Address Space Networking".
 .
 This package provides the static libraries and include files for GasNET.

Package: gasnet
Architecture: any
Multi-Arch: foreign
Depends: 
         ${misc:Depends},
  	 ${perl:Depends},
         ${shlibs:Depends}
Description: Global-Address Space Networking - binary tools
 GASNet is a language-independent, networking middleware layer that provides
 network-independent, high-performance communication primitives including
 Remote Memory Access (RMA) and Active Messages (AM).
 It has been used to implement parallel programming models and libraries
 such as UPC, UPC++, Fortran coarrays, Legion, Chapel, and many others.
 The interface is primarily intended as a compilation target and for use
 by runtime library writers (as opposed to end users), and the primary goals
 are high performance, interface portability, and expressiveness.
 GASNet stands for "Global-Address Space Networking".
 .
 This package includes the program binaries necessary to run GasNET programs.
