=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1


DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
PKGDIR = debian/libgasnet-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig


%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- --enable-ucx


execute_after_dh_install:
	rm -rf $(PKGDIR)
	# Move the perlstart scripts
	mkdir -p debian/gasnet/usr/share/gasnet
	mv debian/gasnet/usr/bin/*.pl debian/gasnet/usr/share/gasnet


#override_dh_gencontrol:
#        dh_gencontrol -- -V'archlist:ucx=$(CH4_UCX_ARCH)'
